diff --git a/src/Lunr/Vortex/JPush/JPushResponse.php b/src/Lunr/Vortex/JPush/JPushResponse.php
index 5c853a925261821ec8c6881229b5fcdfaf743bfe..956e616d741a8d7b4a4b0f80b8be103fdf37c7ae 100644
--- a/src/Lunr/Vortex/JPush/JPushResponse.php
+++ b/src/Lunr/Vortex/JPush/JPushResponse.php
@@ -24,7 +24,7 @@ class JPushResponse implements PushNotificationResponseInterface
      * The statuses per endpoint.
      * @var array<string,PushNotificationStatus::*>
      */
-    protected $statuses;
+    protected array $statuses;
 
     /**
      * Constructor.
@@ -50,7 +50,7 @@ class JPushResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    public function add_batch_response($batch_response, $endpoints)
+    public function add_batch_response(JPushBatchResponse $batch_response, array $endpoints)
     {
         foreach ($endpoints as $endpoint)
         {
@@ -65,7 +65,7 @@ class JPushResponse implements PushNotificationResponseInterface
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         return isset($this->statuses[$endpoint]) ? $this->statuses[$endpoint] : PushNotificationStatus::UNKNOWN;
     }
diff --git a/src/Lunr/Vortex/JPush/Tests/JPushDispatcherBaseTest.php b/src/Lunr/Vortex/JPush/Tests/JPushDispatcherBaseTest.php
index 43bb6cc01490585396a8424e3a2579ff14319381..fe23671a75a83cf993b2f6e998e72961160098a9 100644
--- a/src/Lunr/Vortex/JPush/Tests/JPushDispatcherBaseTest.php
+++ b/src/Lunr/Vortex/JPush/Tests/JPushDispatcherBaseTest.php
@@ -77,12 +77,8 @@ class JPushDispatcherBaseTest extends JPushDispatcherTest
      */
     public function testGetBatchResponseReturnsJPushBatchResponseObject(): void
     {
-        $this->http->expects($this->atLeast(1))
-                   ->method('__get')
-                   ->willReturnMap([['success', FALSE]]);
-
         $method = $this->get_accessible_reflection_method('get_batch_response');
-        $result = $method->invokeArgs($this->class, [ $this->http, $this->logger, [ 'endpoint' ], '{}' ]);
+        $result = $method->invokeArgs($this->class, [ $this->response, [ 'endpoint' ], [] ]);
 
         $this->assertInstanceOf('Lunr\Vortex\JPush\JPushBatchResponse', $result);
     }
diff --git a/src/Lunr/Vortex/JPush/Tests/JPushDispatcherTest.php b/src/Lunr/Vortex/JPush/Tests/JPushDispatcherTest.php
index 86eba3e5cb4c136da3e0a4d70e1689b7d55c1dc3..70c042a7ddac24835cd29889b35ccd5b7009e306 100644
--- a/src/Lunr/Vortex/JPush/Tests/JPushDispatcherTest.php
+++ b/src/Lunr/Vortex/JPush/Tests/JPushDispatcherTest.php
@@ -29,6 +29,11 @@ abstract class JPushDispatcherTest extends LunrBaseTest
      * @var \Requests_Session
      */
     protected $http;
+    /**
+     * Mock instance of the Requests_Response class.
+     * @var \Requests_Response
+     */
+    protected $response;
 
     /**
      * Mock instance of a Logger class.
@@ -47,10 +52,10 @@ abstract class JPushDispatcherTest extends LunrBaseTest
      */
     public function setUp(): void
     {
-        $this->http   = $this->getMockBuilder('Requests_Session')->getMock();
-        $this->logger = $this->getMockBuilder('Psr\Log\LoggerInterface')->getMock();
-
-        $this->payload = $this->getMockBuilder('Lunr\Vortex\JPush\JPushPayload')
+        $this->http     = $this->getMockBuilder('\Requests_Session')->getMock();
+        $this->response = $this->getMockBuilder('\Requests_Response')->getMock();
+        $this->logger   = $this->getMockBuilder('Psr\Log\LoggerInterface')->getMock();
+        $this->payload  = $this->getMockBuilder('Lunr\Vortex\JPush\JPushPayload')
                               ->disableOriginalConstructor()
                               ->getMock();
 
@@ -65,6 +70,7 @@ abstract class JPushDispatcherTest extends LunrBaseTest
     public function tearDown(): void
     {
         unset($this->http);
+        unset($this->response);
         unset($this->logger);
         unset($this->payload);
         unset($this->class);
diff --git a/src/Lunr/Vortex/JPush/Tests/JPushMessagePayloadSetTest.php b/src/Lunr/Vortex/JPush/Tests/JPushMessagePayloadSetTest.php
index 33fb232fa53211b979ae8cb85f0413411b74a0aa..5e113a4522def6f729ad51b30172c2eceeedc64e 100644
--- a/src/Lunr/Vortex/JPush/Tests/JPushMessagePayloadSetTest.php
+++ b/src/Lunr/Vortex/JPush/Tests/JPushMessagePayloadSetTest.php
@@ -66,7 +66,7 @@ class JPushMessagePayloadSetTest extends JPushMessagePayloadTest
      */
     public function testSetTimeToLiveReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_time_to_live('time_to_live'));
+        $this->assertSame($this->class, $this->class->set_time_to_live(1));
     }
 
     /**
@@ -92,7 +92,7 @@ class JPushMessagePayloadSetTest extends JPushMessagePayloadTest
      */
     public function testSetDataReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_data('data'));
+        $this->assertSame($this->class, $this->class->set_data([]));
     }
 
     /**
diff --git a/src/Lunr/Vortex/JPush/Tests/JPushNotificationPayloadSetTest.php b/src/Lunr/Vortex/JPush/Tests/JPushNotificationPayloadSetTest.php
index 9e7219692f152951709d041fac7d0fe8577e039d..ff4ef3d98a646870333648c6e691a045c9a2bd6c 100644
--- a/src/Lunr/Vortex/JPush/Tests/JPushNotificationPayloadSetTest.php
+++ b/src/Lunr/Vortex/JPush/Tests/JPushNotificationPayloadSetTest.php
@@ -66,7 +66,7 @@ class JPushNotificationPayloadSetTest extends JPushNotificationPayloadTest
      */
     public function testSetTimeToLiveReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_time_to_live('time_to_live'));
+        $this->assertSame($this->class, $this->class->set_time_to_live(1));
     }
 
     /**
@@ -91,7 +91,7 @@ class JPushNotificationPayloadSetTest extends JPushNotificationPayloadTest
      */
     public function testSetPriorityInvalid(): void
     {
-        $this->class->set_priority('cow');
+        $this->class->set_priority(25);
 
         $value = $this->get_reflection_property_value('elements');
 
@@ -106,7 +106,7 @@ class JPushNotificationPayloadSetTest extends JPushNotificationPayloadTest
      */
     public function testSetPriorityReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_priority('high'));
+        $this->assertSame($this->class, $this->class->set_priority(1));
     }
 
     /**
@@ -157,7 +157,7 @@ class JPushNotificationPayloadSetTest extends JPushNotificationPayloadTest
      */
     public function testSetDataReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_data('data'));
+        $this->assertSame($this->class, $this->class->set_data([]));
     }
 
     /**
diff --git a/src/Lunr/Vortex/MPNS/MPNSDispatcher.php b/src/Lunr/Vortex/MPNS/MPNSDispatcher.php
index 763ba66a4dd75eabd7772517a7df0f2165734659..0e8d1e17819e2975abfd9c672ad699ec2bfe96fa 100644
--- a/src/Lunr/Vortex/MPNS/MPNSDispatcher.php
+++ b/src/Lunr/Vortex/MPNS/MPNSDispatcher.php
@@ -12,6 +12,8 @@
 namespace Lunr\Vortex\MPNS;
 
 use Lunr\Vortex\PushNotificationDispatcherInterface;
+use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 use Requests_Exception;
 use Requests_Response;
 
@@ -25,13 +27,13 @@ class MPNSDispatcher implements PushNotificationDispatcherInterface
      * Shared instance of the Requests_Session class.
      * @var \Requests_Session
      */
-    private $http;
+    private \Requests_Session $http;
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    private $logger;
+    private LoggerInterface $logger;
 
     /**
      * Constructor.
@@ -39,7 +41,7 @@ class MPNSDispatcher implements PushNotificationDispatcherInterface
      * @param \Requests_Session        $http   Shared instance of the Requests_Session class.
      * @param \Psr\Log\LoggerInterface $logger Shared instance of a Logger.
      */
-    public function __construct($http, $logger)
+    public function __construct(\Requests_Session $http, LoggerInterface $logger)
     {
         $this->http     = $http;
         $this->logger   = $logger;
@@ -60,9 +62,9 @@ class MPNSDispatcher implements PushNotificationDispatcherInterface
      * @param MPNSPayload $payload   Payload object
      * @param array       $endpoints Endpoints to send to in this batch
      *
-     * @return MPNSResponse Response object
+     * @return PushNotificationResponseInterface&MPNSResponse Response object
      */
-    public function push($payload, &$endpoints)
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface
     {
         $type = MPNSType::RAW;
         if ($payload instanceof MPNSToastPayload)
@@ -114,7 +116,7 @@ class MPNSDispatcher implements PushNotificationDispatcherInterface
      *
      * @return \Requests_Response New instance of a Requests_Response object.
      */
-    protected function get_new_response_object_for_failed_request($endpoint)
+    protected function get_new_response_object_for_failed_request(string $endpoint): \Requests_Response
     {
         $http_response = new Requests_Response();
 
diff --git a/src/Lunr/Vortex/MPNS/MPNSPayload.php b/src/Lunr/Vortex/MPNS/MPNSPayload.php
index c79ab4b5d41a479f327b3b7f38496ca4404c8837..369f2e8e59b8075b545f100688194cbeade9a74e 100644
--- a/src/Lunr/Vortex/MPNS/MPNSPayload.php
+++ b/src/Lunr/Vortex/MPNS/MPNSPayload.php
@@ -23,13 +23,13 @@ abstract class MPNSPayload
      * Array of Push Notification elements.
      * @var array
      */
-    protected $elements;
+    protected array $elements;
 
     /**
      * Priority of the payload.
-     * @var integer
+     * @var MPNSPriority::*
      */
-    protected $priority = MPNSPriority::DEFAULT;
+    protected int $priority = MPNSPriority::DEFAULT;
 
     /**
      * Constructor.
@@ -55,7 +55,7 @@ abstract class MPNSPayload
      *
      * @return string Escaped string
      */
-    protected function escape_string($string)
+    protected function escape_string(string $string): string
     {
         $search  = [ '&', '<', '>', '‘', '“' ];
         $replace = [ '&amp;', '&lt;', '&gt;', '&apos;', '&quot;' ];
@@ -68,7 +68,7 @@ abstract class MPNSPayload
      *
      * @return string Payload
      */
-    public abstract function get_payload();
+    public abstract function get_payload(): string;
 
     /**
      * Mark the notification priority.
@@ -77,7 +77,7 @@ abstract class MPNSPayload
      *
      * @return MPNSPayload Self Reference
      */
-    public function set_priority($priority)
+    public function set_priority(int $priority): self
     {
         $mpns = new ReflectionClass('\Lunr\Vortex\MPNS\MPNSPriority');
         if (in_array($priority, $mpns->getConstants()))
diff --git a/src/Lunr/Vortex/MPNS/MPNSPriority.php b/src/Lunr/Vortex/MPNS/MPNSPriority.php
index 13dbc3c175831050d645c7cb101ae4b852092cc5..310067c74e6c2cd229312ba283b040a0afba28cc 100644
--- a/src/Lunr/Vortex/MPNS/MPNSPriority.php
+++ b/src/Lunr/Vortex/MPNS/MPNSPriority.php
@@ -21,61 +21,61 @@ class MPNSPriority
      * Initial priority.
      * @var integer
      */
-    const DEFAULT = 0;
+    public const DEFAULT = 0;
 
     /**
      * Deliver Tile notification immediately.
      * @var integer
      */
-    const TILE_IMMEDIATELY = 1;
+    public const TILE_IMMEDIATELY = 1;
 
     /**
      * Deliver Tile notification within 450 seconds.
      * @var integer
      */
-    const TILE_WAIT_450 = 11;
+    public const TILE_WAIT_450 = 11;
 
     /**
      * Deliver Tile notification within 900 seconds.
      * @var integer
      */
-    const TILE_WAIT_900 = 21;
+    public const TILE_WAIT_900 = 21;
 
     /**
      * Deliver Toast notification immediately.
      * @var integer
      */
-    const TOAST_IMMEDIATELY = 2;
+    public const TOAST_IMMEDIATELY = 2;
 
     /**
      * Deliver Toast notification within 450 seconds.
      * @var integer
      */
-    const TOAST_WAIT_450 = 12;
+    public const TOAST_WAIT_450 = 12;
 
     /**
      * Deliver Toast notification within 900 seconds.
      * @var integer
      */
-    const TOAST_WAIT_900 = 22;
+    public const TOAST_WAIT_900 = 22;
 
     /**
      * Deliver Raw notification immediately.
      * @var integer
      */
-    const RAW_IMMEDIATELY = 3;
+    public const RAW_IMMEDIATELY = 3;
 
     /**
      * Deliver Raw notification within 450 seconds.
      * @var integer
      */
-    const RAW_WAIT_450 = 13;
+    public const RAW_WAIT_450 = 13;
 
     /**
      * Deliver Raw notification within 900 seconds.
      * @var integer
      */
-    const RAW_WAIT_900 = 23;
+    public const RAW_WAIT_900 = 23;
 
 }
 
diff --git a/src/Lunr/Vortex/MPNS/MPNSResponse.php b/src/Lunr/Vortex/MPNS/MPNSResponse.php
index a9c6e3fddd8c0ef217339b0042180cae33834249..bcaa2a21d4032dec61299600fd238abbc1999e63 100644
--- a/src/Lunr/Vortex/MPNS/MPNSResponse.php
+++ b/src/Lunr/Vortex/MPNS/MPNSResponse.php
@@ -13,6 +13,7 @@ namespace Lunr\Vortex\MPNS;
 
 use Lunr\Vortex\PushNotificationStatus;
 use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 
 /**
  * Windows Phone Push Notification response wrapper.
@@ -22,13 +23,13 @@ class MPNSResponse implements PushNotificationResponseInterface
 
     /**
      * HTTP headers of the response.
-     * @var array
+     * @var \Requests_Response_Headers
      */
-    private $headers;
+    private \Requests_Response_Headers $headers;
 
     /**
      * HTTP status code.
-     * @var integer
+     * @var bool
      */
     private $http_code;
 
@@ -36,19 +37,19 @@ class MPNSResponse implements PushNotificationResponseInterface
      * Delivery status.
      * @var PushNotificationStatus::*
      */
-    private $status;
+    private int $status;
 
     /**
      * Push notification endpoint.
      * @var string
      */
-    private $endpoint;
+    private string $endpoint;
 
     /**
      * Raw payload that was sent to MPNS.
      * @var string
      */
-    protected $payload;
+    protected string $payload;
 
     /**
      * Constructor.
@@ -57,14 +58,16 @@ class MPNSResponse implements PushNotificationResponseInterface
      * @param \Psr\Log\LoggerInterface $logger   Shared instance of a Logger.
      * @param string                   $payload  Raw payload that was sent to MPNS.
      */
-    public function __construct($response, $logger, $payload)
+    public function __construct(\Requests_Response $response, LoggerInterface $logger, string $payload)
     {
         $this->http_code = $response->status_code;
         $this->endpoint  = $response->url;
         $this->payload   = $payload;
 
+
         if ($this->http_code === FALSE)
         {
+            $this->headers = new \Requests_Response_Headers();
             $this->status = PushNotificationStatus::ERROR;
         }
         else
@@ -88,22 +91,26 @@ class MPNSResponse implements PushNotificationResponseInterface
     /**
      * Set response header information.
      *
-     * @param array $headers Response headers
+     * @param \Requests_Response_Headers $headers Response headers
      *
      * @return void
      */
-    private function set_headers($headers)
+    private function set_headers(\Requests_Response_Headers $headers): void
     {
         $this->headers = $headers;
 
         if (in_array($this->http_code, [ 400, 401, 405, 503 ]))
         {
+            unset($this->headers['X-Notificationstatus']);
+            unset($this->headers['X-Deviceconnectionstatus']);
+            unset($this->headers['X-Subscriptionstatus']);
             $this->headers['X-Notificationstatus']     = 'N/A';
             $this->headers['X-Deviceconnectionstatus'] = 'N/A';
             $this->headers['X-Subscriptionstatus']     = 'N/A';
         }
         elseif ($this->http_code === 412)
         {
+            unset($this->headers['X-Subscriptionstatus']);
             $this->headers['X-Subscriptionstatus'] = 'N/A';
         }
     }
@@ -116,7 +123,7 @@ class MPNSResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    private function set_status($endpoint, $logger)
+    private function set_status(string $endpoint, LoggerInterface $logger)
     {
         switch ($this->http_code)
         {
@@ -176,7 +183,7 @@ class MPNSResponse implements PushNotificationResponseInterface
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         if ($endpoint != $this->endpoint)
         {
diff --git a/src/Lunr/Vortex/MPNS/MPNSTilePayload.php b/src/Lunr/Vortex/MPNS/MPNSTilePayload.php
index d7290b4726cb2d850118c9e6e2101c80983eac2a..bd036340c31dc4ff1b43c7b5954bb8277500e515 100644
--- a/src/Lunr/Vortex/MPNS/MPNSTilePayload.php
+++ b/src/Lunr/Vortex/MPNS/MPNSTilePayload.php
@@ -38,7 +38,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return string Payload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         $xml  = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
         $xml .= "<wp:Notification xmlns:wp=\"WPNotification\">\n";
@@ -94,7 +94,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return MPNSTilePayload Self Reference
      */
-    public function set_title($title)
+    public function set_title(string $title): self
     {
         $this->elements['title'] = $this->escape_string($title);
 
@@ -108,7 +108,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return MPNSTilePayload Self Reference
      */
-    public function set_background_image($image)
+    public function set_background_image(string $image): self
     {
         $this->elements['background_image'] = $this->escape_string($image);
 
@@ -122,7 +122,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return MPNSTilePayload Self Reference
      */
-    public function set_count($count)
+    public function set_count(string $count): self
     {
         $this->elements['count'] = $this->escape_string($count);
 
@@ -136,7 +136,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return MPNSTilePayload Self Reference
      */
-    public function set_back_background_image($image)
+    public function set_back_background_image(string $image): self
     {
         $this->elements['back_background_image'] = $this->escape_string($image);
 
@@ -150,7 +150,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return MPNSTilePayload Self Reference
      */
-    public function set_back_title($title)
+    public function set_back_title(string $title): self
     {
         $this->elements['back_title'] = $this->escape_string($title);
 
@@ -164,7 +164,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return MPNSTilePayload Self Reference
      */
-    public function set_back_content($content)
+    public function set_back_content(string $content): self
     {
         $this->elements['back_content'] = $this->escape_string($content);
 
@@ -178,7 +178,7 @@ class MPNSTilePayload extends MPNSPayload
      *
      * @return MPNSTilePayload Self Reference
      */
-    public function set_id($id)
+    public function set_id(string $id): self
     {
         $this->elements['id'] = $this->escape_string($id);
 
diff --git a/src/Lunr/Vortex/MPNS/MPNSToastPayload.php b/src/Lunr/Vortex/MPNS/MPNSToastPayload.php
index f859832116779fa26f48debd04486beeb7a264ea..f7ff27280bb9716cadc6adc1fef451202fc8dc9e 100644
--- a/src/Lunr/Vortex/MPNS/MPNSToastPayload.php
+++ b/src/Lunr/Vortex/MPNS/MPNSToastPayload.php
@@ -11,6 +11,8 @@
 
 namespace Lunr\Vortex\MPNS;
 
+use Psr\Log\LoggerInterface;
+
 /**
  * Windows Phone Toast Push Notification Payload Generator.
  */
@@ -21,14 +23,14 @@ class MPNSToastPayload extends MPNSPayload
      * Shared instance of a Logger.
      * @var \Psr\Log\LoggerInterface
      */
-    private $logger;
+    private LoggerInterface $logger;
 
     /**
      * Constructor.
      *
      * @param \Psr\Log\LoggerInterface $logger Shared instance of a logger
      */
-    public function __construct($logger)
+    public function __construct(LoggerInterface $logger)
     {
         parent::__construct();
 
@@ -50,7 +52,7 @@ class MPNSToastPayload extends MPNSPayload
      *
      * @return string Payload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         $xml  = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
         $xml .= "<wp:Notification xmlns:wp=\"WPNotification\">\n";
@@ -83,7 +85,7 @@ class MPNSToastPayload extends MPNSPayload
      *
      * @return MPNSToastPayload Self Reference
      */
-    public function set_title($title)
+    public function set_title(string $title): self
     {
         $this->elements['title'] = $this->escape_string($title);
 
@@ -97,7 +99,7 @@ class MPNSToastPayload extends MPNSPayload
      *
      * @return MPNSToastPayload Self Reference
      */
-    public function set_message($message)
+    public function set_message(string $message): self
     {
         $this->elements['message'] = $this->escape_string($message);
 
@@ -111,7 +113,7 @@ class MPNSToastPayload extends MPNSPayload
      *
      * @return MPNSToastPayload Self Reference
      */
-    public function set_deeplink($deeplink)
+    public function set_deeplink(string $deeplink): self
     {
         $deeplink = $this->escape_string($deeplink);
 
diff --git a/src/Lunr/Vortex/MPNS/MPNSType.php b/src/Lunr/Vortex/MPNS/MPNSType.php
index 731669a5d18a085cab6f33cb8bf7681015204ee0..91cfc462389e34ce2f42290505f699f1c8b428d5 100644
--- a/src/Lunr/Vortex/MPNS/MPNSType.php
+++ b/src/Lunr/Vortex/MPNS/MPNSType.php
@@ -21,19 +21,19 @@ class MPNSType
      * Tile notification.
      * @var string
      */
-    const TILE = 'token';
+    public const TILE = 'token';
 
     /**
      * Toast notification.
      * @var string
      */
-    const TOAST = 'toast';
+    public const TOAST = 'toast';
 
     /**
      * Raw notification.
      * @var string
      */
-    const RAW = 'raw';
+    public const RAW = 'raw';
 
 }
 
diff --git a/src/Lunr/Vortex/MPNS/Tests/MPNSDispatcherTest.php b/src/Lunr/Vortex/MPNS/Tests/MPNSDispatcherTest.php
index f52319cf95d95b020fe3aee73fb962f697d17fae..87ed6fb554896f5dad5697674e51a3b7ed904133 100644
--- a/src/Lunr/Vortex/MPNS/Tests/MPNSDispatcherTest.php
+++ b/src/Lunr/Vortex/MPNS/Tests/MPNSDispatcherTest.php
@@ -12,6 +12,7 @@
 namespace Lunr\Vortex\MPNS\Tests;
 
 use Lunr\Vortex\MPNS\MPNSDispatcher;
+use Lunr\Vortex\MPNS\MPNSPayload;
 use Lunr\Vortex\MPNS\MPNSPriority;
 use Lunr\Vortex\MPNS\MPNSType;
 use Lunr\Halo\LunrBaseTest;
diff --git a/src/Lunr/Vortex/MPNS/Tests/MPNSResponseErrorTest.php b/src/Lunr/Vortex/MPNS/Tests/MPNSResponseErrorTest.php
index 3b94189b2634dd4d02bf1a0bd489d0a878b84ca1..90df49a638e721396357f28ca4f194481af2da27 100644
--- a/src/Lunr/Vortex/MPNS/Tests/MPNSResponseErrorTest.php
+++ b/src/Lunr/Vortex/MPNS/Tests/MPNSResponseErrorTest.php
@@ -34,7 +34,7 @@ class MPNSResponseErrorTest extends MPNSResponseTest
      */
     public function testHeadersIsNull(): void
     {
-        $this->assertNull($this->get_reflection_property_value('headers'));
+        $this->assertEquals(new \Requests_Response_Headers(), $this->get_reflection_property_value('headers'));
     }
 
     /**
diff --git a/src/Lunr/Vortex/MPNS/Tests/MPNSResponseSetTest.php b/src/Lunr/Vortex/MPNS/Tests/MPNSResponseSetTest.php
index 5c415eb69b1a2c461c6935f87b16846e42966fcb..72e543b5334c62090bb3a5005df756c8a50eb66b 100644
--- a/src/Lunr/Vortex/MPNS/Tests/MPNSResponseSetTest.php
+++ b/src/Lunr/Vortex/MPNS/Tests/MPNSResponseSetTest.php
@@ -36,7 +36,7 @@ class MPNSResponseSetTest extends MPNSResponseTest
      */
     public function testSetHeadersWithPreconditionFailedStatus(): void
     {
-        $headers = [
+        $in_headers = [
             'Date'                     => '2013-07-05',
             'X-Notificationstatus'     => 'Received',
             'X-Deviceconnectionstatus' => 'Connected',
@@ -46,7 +46,7 @@ class MPNSResponseSetTest extends MPNSResponseTest
         $this->set_reflection_property_value('http_code', 412);
 
         $method = $this->get_accessible_reflection_method('set_headers');
-        $method->invokeArgs($this->class, [ $headers ]);
+        $method->invokeArgs($this->class, [ new \Requests_Response_Headers($in_headers) ]);
 
         $headers = $this->get_reflection_property_value('headers');
 
@@ -65,11 +65,11 @@ class MPNSResponseSetTest extends MPNSResponseTest
      * @param integer $status Special status code
      *
      * @dataProvider specialStatusProvider
-     * @covers       Lunr\Vortex\MPNS\MPNSResponse::set_headers
+     * @covers       \Lunr\Vortex\MPNS\MPNSResponse::set_headers
      */
-    public function testSetHeadersWithSpecialStatusCodes($status): void
+    public function testSetHeadersWithSpecialStatusCodes(int $status): void
     {
-        $headers = [
+        $in_headers = [
             'Date'                     => '2013-07-05',
             'X-Notificationstatus'     => 'Received',
             'X-Deviceconnectionstatus' => 'Connected',
@@ -79,7 +79,7 @@ class MPNSResponseSetTest extends MPNSResponseTest
         $this->set_reflection_property_value('http_code', $status);
 
         $method = $this->get_accessible_reflection_method('set_headers');
-        $method->invokeArgs($this->class, [ $headers ]);
+        $method->invokeArgs($this->class, [ new \Requests_Response_Headers($in_headers) ]);
 
         $headers = $this->get_reflection_property_value('headers');
 
@@ -126,7 +126,7 @@ class MPNSResponseSetTest extends MPNSResponseTest
         $headers['X-Deviceconnectionstatus'] = 'N/A';
         $headers['X-Subscriptionstatus']     = 'N/A';
 
-        $this->set_reflection_property_value('headers', $headers);
+        $this->set_reflection_property_value('headers', new \Requests_Response_Headers($headers));
         $this->set_reflection_property_value('http_code', $code);
 
         $context = [
diff --git a/src/Lunr/Vortex/MPNS/Tests/MPNSResponseTest.php b/src/Lunr/Vortex/MPNS/Tests/MPNSResponseTest.php
index 27b3bd954c39e93c09b508264ec52d8675f7c893..a568c32f1d460096f11c12c1e15cc9f46c5f5067 100644
--- a/src/Lunr/Vortex/MPNS/Tests/MPNSResponseTest.php
+++ b/src/Lunr/Vortex/MPNS/Tests/MPNSResponseTest.php
@@ -40,10 +40,11 @@ abstract class MPNSResponseTest extends LunrBaseTest
     {
         $this->logger = $this->getMockBuilder('Psr\Log\LoggerInterface')->getMock();
 
-        $response = $this->getMockBuilder('Requests_Response')->getMock();
+        $response = $this->getMockBuilder('\Requests_Response')->getMock();
 
         $response->status_code = FALSE;
         $response->url         = 'http://localhost/';
+        $response->headers     = new \Requests_Response_Headers();
 
         $this->class      = new MPNSResponse($response, $this->logger, '<?xml version="1.0" encoding="utf-8"?>');
         $this->reflection = new ReflectionClass('Lunr\Vortex\MPNS\MPNSResponse');
@@ -60,7 +61,7 @@ abstract class MPNSResponseTest extends LunrBaseTest
 
         $response = $this->getMockBuilder('Requests_Response')->getMock();
 
-        $response->headers = [
+        $headers = [
             'Date'                     => '2013-07-05',
             'X-Notificationstatus'     => 'Received',
             'X-Deviceconnectionstatus' => 'Connected',
@@ -69,6 +70,7 @@ abstract class MPNSResponseTest extends LunrBaseTest
 
         $response->status_code = 200;
         $response->url         = 'http://localhost/';
+        $response->headers     = new \Requests_Response_Headers($headers);
 
         $this->class      = new MPNSResponse($response, $this->logger, '<?xml version="1.0" encoding="utf-8"?>');
         $this->reflection = new ReflectionClass('Lunr\Vortex\MPNS\MPNSResponse');
diff --git a/src/Lunr/Vortex/PAP/PAPDispatcher.php b/src/Lunr/Vortex/PAP/PAPDispatcher.php
index 5838a7be481fb3f299ae6891821cfef83da6ab75..d8966c712d5e1860f09e1e08ea0d21f9bd8bf019 100644
--- a/src/Lunr/Vortex/PAP/PAPDispatcher.php
+++ b/src/Lunr/Vortex/PAP/PAPDispatcher.php
@@ -13,6 +13,7 @@
 namespace Lunr\Vortex\PAP;
 
 use Lunr\Vortex\PushNotificationDispatcherInterface;
+use Lunr\Vortex\PushNotificationResponseInterface;
 use Requests_Exception;
 use Requests_Response;
 
@@ -99,9 +100,9 @@ class PAPDispatcher implements PushNotificationDispatcherInterface
      * @param PAPPayload $payload   Payload object
      * @param array      $endpoints Endpoints to send to in this batch
      *
-     * @return PAPResponse Response object
+     * @return PushNotificationResponseInterface&PAPResponse Response object
      */
-    public function push($payload, &$endpoints)
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface
     {
         // construct PAP URL
         $pap_url = "https://cp{$this->cid}.pushapi.na.blackberry.com/mss/PD_pushRequest";
diff --git a/src/Lunr/Vortex/PAP/PAPPayload.php b/src/Lunr/Vortex/PAP/PAPPayload.php
index 13a624530f8597a10df0c10e71f2d7966d6a90a0..5e98f8e298850d307a62f4191e44a146a9e454d1 100644
--- a/src/Lunr/Vortex/PAP/PAPPayload.php
+++ b/src/Lunr/Vortex/PAP/PAPPayload.php
@@ -21,7 +21,7 @@ class PAPPayload
      * Array of Push Notification message elements.
      * @var array
      */
-    protected $data;
+    protected array $data;
 
     /**
      * Push Notification deliver before timestamp.
@@ -50,7 +50,7 @@ class PAPPayload
      *
      * @return string The PAP Payload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         return json_encode($this->data);
     }
@@ -65,7 +65,7 @@ class PAPPayload
      *
      * @return PAPPayload Self Reference
      */
-    public function set_message_data($key, $value)
+    public function set_message_data(string $key, string $value): self
     {
         $this->data[$key] = $value;
 
@@ -79,7 +79,7 @@ class PAPPayload
      *
      * @return PAPPayload Self Reference
      */
-    public function set_priority($priority)
+    public function set_priority(int $priority): self
     {
         $this->priority = $priority;
 
